<?php
//Blosxom On PHP
//An unnecessary, and likely fruitless port by: Thomas Wilburn
//Version: 1.0
//Based on Rael Dornfest's awesome (but unscaleable) Blosxom blogging software
$time_start = microtime(true);
ob_start();

// --- Configurable variables ---

//What's this blog's title?
$blog_title = "";

//What's this blog's description (for outgoing RSS feed)?
$blog_description = "";

//Where are this blog's entries kept?
$datadir = "";

//What's my preferred base URL for this blog?
$url = "";

//How many entries should I show on the home page?
$num_entries = 10;

//What file extension signifies a blosxom entry?
$file_extension = "txt";

//What is the default flavor?
$default_flavor = "html";

//Do you want to output elapsed time at the end?
$benchmark = false;

// --- Plugins (Optional) ---

//Where are my plugins kept?
$plugin_dir = "";

//Where should my modules keep their state information?
$plugin_state_dir = "$plugin_dir/state";

// --------------------------
// BEGIN ACTUAL CODE
// --------------------------

//CONSTANTS

$month2num = Array(null=>0, "Jan"=>1, "Feb"=>2, "Mar"=>3, "Apr"=>4, "May"=>5, "Jun"=>6, "Jul"=>7, "Aug"=>8, "Sep"=>9, "Oct"=>10, "Nov"=>11, "Dec"=>12);
$num2month = array_flip($month2num);

//Flavor variables:
$head;
$foot;
$story;
$date;
$content_type;
$fourohfour;

//Content variables:
$entryPlugins = array();
$globalPlugins = array();
$document = "";

//INIT FROM URL PARAMETERS
$start = $_GET['start'];
if (!$start) $start = 0;
$path_info = $_SERVER['PATH_INFO'];
$flavor = $_GET['flav'];
if (!$flavor) {
	$path_parts = pathinfo($path_info);
	if ($path_parts['extension']) {
		$flavor = $path_parts['extension'];
		//$path_info = $path_parts['dirname'];
		$storyfile = $path_parts['filename'];
	} else {
		$flavor = $default_flavor;
	}
}

//EXECUTABLE
load_flavors($flavor);
header("Content-Type: $content_type");
load_plugins();
//First question: is this a request from a single entry (a file name was specified) or a category?
if (!$storyfile) {
	$srcfiles = get_dirlist_recursive("$datadir$path_info", $file_extension);
	
	//So there's all this code here from when I was trying to speed things up by caching the initial file system crawl.
	//Turns out that caching a recursive crawl based on an arbitrary start point is more complicated than I thought.
	//It's commented out for now, but it wasn't a bad idea, and one day I might put it back.
	
	/*$cachetime = filemtime("$datadir/entrycache.dat");
	$nowtime = getdate();
	if (!$cachetime) {
		$cachetime = getdate();
		$cachetime['minutes'] -= 10;
	} else {
		$cachetime = getdate($cachetime);
	}
	if ($_GET['reindex'] == 'y' OR $cachetime['minutes'] % 55 < $nowtime['minutes'] - 2) {
		$srcfiles = get_dirlist_recursive("$datadir", $file_extension);
		$entrycache = serialize($srcfiles);
		$handle = fopen("$datadir/entrycache.dat", 'w');
		//if ($handle == false) echo "couldn't open cache file for writing";
		//if (is_writeable("$datadir/entrycache.dat") == false) echo "cache not writable";
		fwrite($handle, $entrycache);
		fclose($handle);
	} else {
		//echo ($cachetime['minutes'] % 55) . " " . ($nowtime['minutes'] - 2);
		$entrycache = file_get_contents("$datadir/entrycache.dat");
		$srcfiles = unserialize($entrycache);
	}
	if ($path_info) {
		$srcfiles = array_filter($srcfiles, "filter_files_by_path");
		$srcfiles = array_merge($srcfiles);
	}*/
	
} else {
	$singlefile = array('filename'=>$path_parts['filename'], 'dir'=>$datadir . $path_parts['dirname'], 'mtime'=>filemtime($datadir . $path_parts['dirname']));
	$singlefile['rel_path'] = str_replace($datadir, '', $path_parts['dirname']);
	$srcfiles = array($singlefile);
}

//If we supported custom sorting plugins, they'd be called here instead of the usort() function.

usort($srcfiles, "sort_files_by_date");
$srcfiles = array_slice($srcfiles, $start, $num_entries);

$document = $head;
$currentdate;

//GENERATE ENTRIES - SHOULD PROBABLY REFACTOR AS A FUNCTION, AND ADD MORE PLUGIN PROCESSING
$foundStory = false;
foreach ($srcfiles as $item) {
	$filepath = "{$item['dir']}/{$item['filename']}.$file_extension";
	$h = fopen($filepath, "r");
	if ($h != false) {
		$title = fgets($h);
		$body = fread($h, filesize($filepath));
		if ($flavor == "rss") $body = htmlspecialchars($body);
		$entrydate = getdate($item['mtime']);
		$entry = "";
		if ($entrydate['mon'] . $entrydate['mday'] != $currentdate) {
			$currentdate = $entrydate['mon'] . $entrydate['mday'];
			$entry .= $date;
		}
		$entry .= $story;
		//When it finds the following variables in the template files, it will replace them with entry content.
		$entry = str_replace('$title', $title, $entry);
		$entry = str_replace('$body', $body, $entry);
		$entry = str_replace('$yr', $entrydate['year'], $entry);
		$entry = str_replace('$mo', $entrydate['month'], $entry);
		$entry = str_replace('$mo_num', $entrydate['mon'], $entry);
		$entry = str_replace('$da', $entrydate['mday'], $entry);
		$entry = str_replace('$hr', $entrydate['hours'], $entry);
		$entry = str_replace('$min', date("i", $entrydate[0]), $entry);
		$entry = str_replace('$path', $item['rel_path'], $entry);
		$entry = str_replace('$fn', $item['filename'], $entry);
		foreach ($entryPlugins as $plugin) {
			//Process each entry through registered plugins, using the process() method
			//process() takes the entry text, as well as the file info hash for the source file
			$entry = $plugin->process($entry, $item);
		}
		fclose($h);
		$document .= $entry;
		$foundStory = true;
	}
}

if ($foundStory == false) $document .= $fourohfour;

$document .= $foot;

$document = str_replace('$blog_title', $blog_title, $document);
$document = str_replace('$blog_description', $blog_description, $document);
$document = str_replace('$url', $url, $document);
$document = str_replace('$path_info', $pathinfo, $document);
$document = str_replace('$flavour', $flavor, $document);
$document = str_replace('$flavor', $flavor, $document);
//I just went ahead and built the moreentries plugin into this version. It was simple enough to do, why not?
$document = str_replace('$moreentries::nextlink', '?start=' . ($start+$num_entries), $document);
if ($start >= $num_entries) {
	$prevlink = '?start=' . ($start - $num_entries);
}
$document = str_replace('$moreentries::prevlink', $prevlink, $document);

//GLOBAL DOCUMENT PLUGIN SUPPORT WOULD GO HERE, IF WE HAD IT.

//Output document

echo $document;

//LIBRARY FUNCTIONS

function filter_files_by_path($a) {
	global $path_info;
	$seek = $a['rel_path'];
	if (strpos($seek, $path_info) === 0) {
		return true;
	} else {
		return false;
	}
}

function sort_files_by_date($a, $b) {
	if ($a['mtime'] < $b['mtime']) return 1;
	return -1;
}

function get_dirlist_recursive($dir, $extension) {
	global $datadir;
	$flist = array();
	if (is_dir($dir)) {
		$handle = opendir($dir);
		while (FALSE !== ($file = readdir($handle))) {
			$path = $dir . '/' . $file;
			if ($file != '.' && $file != '..' && file_exists($path)) {
				if (is_dir($path)) {
					$flist = array_merge($flist, get_dirlist_recursive($path, $extension));
				} else {
					$fileinfo = pathinfo($path);
					if ($fileinfo['extension'] == $extension) {
						//If we supported custom file filtering plugins, they'd be called here, during the recursive crawl
						$entry = array('filename'=>$fileinfo['filename'], 'dir'=>$dir, 'mtime'=>filemtime($path));
						$entry['rel_path'] = str_replace($datadir, '', $fileinfo['dirname']);
						$flist[] = $entry;
					}
				}
			}
		}
		closedir($handle);
	}
	return $flist;
}

function load_flavors($flav) {
	global $datadir, $head, $foot, $story, $date, $content_type, 
$fourohfour;
	if ($flav == "rss") {
		//Just as with the original, I went ahead and built the RSS flavor into the file.
		$head = "<?xml version='1.0'?>\n<rss version=\"2.0\">\n" . '<channel>' . "\n" . '<title>$blog_title</title>'."\n".'<link>$url</link>'."\n".'<description>$blog_description</description>'."\n<language>en</language>\n".'<generator>Bloxsom on PHP</generator>'."\n";
		$story = '<item>'."\n".'<title>$title</title>'."\n".'<link>$url$path/$fn.html</link>'."\n".'<description>$body</description>'."\n".'<pubDate>$da $mo $yr $hr:$min EST</pubDate>'."\n".'<guid>$url$path/$fn.html</guid>'."\n</item>\n";
		$date = "\n";
		$foot = "</channel></rss>";
		$content_type = "application/xhtml+xml";
		$fourohfour = "";
	} else {
		//Templates consist of up to 6 files, each with the extension of the flavor you want.
		//So by default, these are head.html, foot.html, story.html, date.html, content_type.html, and fourohfour.html.
		$head = fread(fopen("$datadir/head.$flav", 'r'), filesize("$datadir/head.$flav"));
		$foot = fread(fopen("$datadir/foot.$flav", 'r'), filesize("$datadir/foot.$flav"));
		$story = fread(fopen("$datadir/story.$flav", 'r'), filesize("$datadir/story.$flav"));
		$date = fread(fopen("$datadir/date.$flav", 'r'), filesize("$datadir/date.$flav"));
		$content_type = fread(fopen("$datadir/content_type.$flav", 'r'), filesize("$datadir/content_type.$flav"));
		$fourohfour = fread(fopen("$datadir/404.$flav", 'r'), filesize("$datadir/404.$flav"));
		if (!$content_type) $content_type = "text/html";
	}
}

function load_plugins() {
	global $plugin_dir, $entryPlugins, $globalPlugins;
	$handle = opendir($plugin_dir);
	while (FALSE !== ($file = readdir($handle))) {
		$filepath = pathinfo("$plugin_dir/$file");
		if ($filepath['extension'] == "php") {
			include("$plugin_dir/$file");
		}
	}
}

if ($benchmark) echo "Elapsed: " . (int)((microtime(true) - $time_start) 
* 1000) . "ms";

ob_end_flush();

?>
